Index: netinet/ip_flow.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet/ip_flow.c,v
retrieving revision 1.16
diff -u -p -r1.16 ip_flow.c
--- netinet/ip_flow.c	8 Nov 2003 23:36:31 -0000	1.16
+++ netinet/ip_flow.c	11 Nov 2003 18:18:18 -0000
@@ -1,377 +1 @@
-/*-
- * Copyright (c) 1998 The NetBSD Foundation, Inc.
- * All rights reserved.
- *
- * This code is derived from software contributed to The NetBSD Foundation
- * by the 3am Software Foundry ("3am").  It was developed by Matt Thomas.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. All advertising materials mentioning features or use of this software
- *    must display the following acknowledgement:
- *	This product includes software developed by the NetBSD
- *	Foundation, Inc. and its contributors.
- * 4. Neither the name of The NetBSD Foundation nor the names of its
- *    contributors may be used to endorse or promote products derived
- *    from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
- * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
- * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
- * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
- * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- *
- * $FreeBSD: src/sys/netinet/ip_flow.c,v 1.16 2003/11/08 23:36:31 sam Exp $
- */
 
-#include <sys/param.h>
-#include <sys/systm.h>
-#include <sys/lock.h>
-#include <sys/malloc.h>
-#include <sys/mbuf.h>
-#include <sys/mutex.h>
-#include <sys/protosw.h>
-#include <sys/socket.h>
-#include <sys/kernel.h>
-
-#include <sys/sysctl.h>
-
-#include <net/if.h>
-#include <net/route.h>
-
-#include <netinet/in.h>
-#include <netinet/in_systm.h>
-#include <netinet/ip.h>
-#include <netinet/in_var.h>
-#include <netinet/ip_var.h>
-#include <netinet/ip_flow.h>
-
-#define	IPFLOW_TIMER		(5 * PR_SLOWHZ)
-#define IPFLOW_HASHBITS		6	/* should not be a multiple of 8 */
-#define	IPFLOW_HASHSIZE		(1 << IPFLOW_HASHBITS)
-#if IPFLOW_HASHSIZE > 255
-#error "make ipf_hash larger"
-#endif
-static struct ipflow_head ipflows[IPFLOW_HASHSIZE];
-static int ipflow_inuse;
-#define	IPFLOW_MAX		256
-
-/*
- * Each flow list has a lock that guards updates to the list and to
- * all entries on the list.  Flow entries hold the hash index for
- * finding the head of the list so the lock can be found quickly.
- *
- * ipflow_inuse holds a count of the number of flow entries present.
- * This is used to bound the size of the table.  When IPFLOW_MAX entries
- * are present and an additional entry is needed one is chosen for
- * replacement.  We could use atomic ops for this counter but having it
- * inconsistent doesn't appear to be a problem.
- */
-#define	IPFLOW_HEAD_LOCK(_ipfh)		mtx_lock(&(_ipfh)->ipfh_mtx)
-#define	IPFLOW_HEAD_UNLOCK(_ipfh)	mtx_unlock(&(_ipfh)->ipfh_mtx)
-#define	IPFLOW_LOCK(_ipf) \
-	IPFLOW_HEAD_LOCK(&ipflows[(_ipf)->ipf_hash])
-#define	IPFLOW_UNLOCK(_ipf) \
-	IPFLOW_HEAD_UNLOCK(&ipflows[(_ipf)->ipf_hash])
-
-static int ipflow_active = 0;
-SYSCTL_INT(_net_inet_ip, IPCTL_FASTFORWARDING, fastforwarding, CTLFLAG_RW,
-    &ipflow_active, 0, "Enable flow-based IP forwarding");
-
-static MALLOC_DEFINE(M_IPFLOW, "ip_flow", "IP flow");
-
-static unsigned
-ipflow_hash(struct in_addr dst, struct in_addr src, unsigned tos)
-{
-	unsigned hash = tos;
-	int idx;
-	for (idx = 0; idx < 32; idx += IPFLOW_HASHBITS)
-		hash += (dst.s_addr >> (32 - idx)) + (src.s_addr >> idx);
-	return hash & (IPFLOW_HASHSIZE-1);
-}
-
-static struct ipflow *
-ipflow_lookup(const struct ip *ip)
-{
-	unsigned hash;
-	struct ipflow_head *head;
-	struct ipflow *ipf;
-
-	hash = ipflow_hash(ip->ip_dst, ip->ip_src, ip->ip_tos);
-	head = &ipflows[hash];
-
-	IPFLOW_HEAD_LOCK(head);
-	LIST_FOREACH(ipf, &head->ipfh_head, ipf_next) {
-		if (ip->ip_dst.s_addr == ipf->ipf_dst.s_addr
-		    && ip->ip_src.s_addr == ipf->ipf_src.s_addr
-		    && ip->ip_tos == ipf->ipf_tos) {
-			/* NB: return head locked */
-			return ipf;
-		}
-	}
-	IPFLOW_HEAD_UNLOCK(head);
-	return NULL;
-}
-
-int
-ipflow_fastforward(struct mbuf *m)
-{
-	struct ip *ip;
-	struct ipflow *ipf;
-	struct rtentry *rt;
-	struct sockaddr *dst;
-	int error;
-
-	/*
-	 * Are we forwarding packets?  Big enough for an IP packet?
-	 */
-	if (!ipforwarding || !ipflow_active || m->m_len < sizeof(struct ip))
-		return 0;
-	/*
-	 * IP header with no option and valid version and length
-	 */
-	ip = mtod(m, struct ip *);
-	if (ip->ip_v != IPVERSION || ip->ip_hl != (sizeof(struct ip) >> 2)
-	    || ntohs(ip->ip_len) > m->m_pkthdr.len)
-		return 0;
-	/*
-	 * Find a flow.
-	 */
-	if ((ipf = ipflow_lookup(ip)) == NULL)
-		return 0;
-
-	/*
-	 * Route and interface still up?
-	 */
-	rt = ipf->ipf_ro.ro_rt;
-	if ((rt->rt_flags & RTF_UP) == 0 || (rt->rt_ifp->if_flags & IFF_UP) == 0) {
-		IPFLOW_UNLOCK(ipf);
-		return 0;
-	}
-
-	/*
-	 * Packet size OK?  TTL?
-	 */
-	if (m->m_pkthdr.len > rt->rt_ifp->if_mtu || ip->ip_ttl <= IPTTLDEC) {
-		IPFLOW_UNLOCK(ipf);
-		return 0;
-	}
-
-	/*
-	 * Everything checks out and so we can forward this packet.
-	 * Modify the TTL and incrementally change the checksum.
-	 */
-	ip->ip_ttl -= IPTTLDEC;
-	if (ip->ip_sum >= htons(0xffff - (IPTTLDEC << 8))) {
-		ip->ip_sum += htons(IPTTLDEC << 8) + 1;
-	} else {
-		ip->ip_sum += htons(IPTTLDEC << 8);
-	}
-
-	/*
-	 * Send the packet on its way.  All we can get back is ENOBUFS
-	 */
-	ipf->ipf_uses++;
-	ipf->ipf_timer = IPFLOW_TIMER;
-
-	if (rt->rt_flags & RTF_GATEWAY)
-		dst = rt->rt_gateway;
-	else
-		dst = &ipf->ipf_ro.ro_dst;
-	if ((error = (*rt->rt_ifp->if_output)(rt->rt_ifp, m, dst, rt)) != 0) {
-		if (error == ENOBUFS)
-			ipf->ipf_dropped++;
-		else
-			ipf->ipf_errors++;
-	}
-	IPFLOW_UNLOCK(ipf);
-	return 1;
-}
-
-static void
-ipflow_addstats(struct ipflow *ipf)
-{
-	ipf->ipf_ro.ro_rt->rt_use += ipf->ipf_uses;
-	ipstat.ips_cantforward += ipf->ipf_errors + ipf->ipf_dropped;
-	ipstat.ips_forward += ipf->ipf_uses;
-	ipstat.ips_fastforward += ipf->ipf_uses;
-}
-
-/*
- * XXX the locking here makes reaping an entry very expensive...
- */
-static struct ipflow *
-ipflow_reap(void)
-{
-	struct ipflow *victim = NULL;
-	struct ipflow *ipf;
-	int idx;
-
-	for (idx = 0; idx < IPFLOW_HASHSIZE; idx++) {
-		struct ipflow_head *head = &ipflows[idx];
-
-		IPFLOW_HEAD_LOCK(head);
-		LIST_FOREACH(ipf, &head->ipfh_head, ipf_next) {
-			/*
-			 * If this no longer points to a valid route
-			 * reclaim it.
-			 */
-			if ((ipf->ipf_ro.ro_rt->rt_flags & RTF_UP) == 0)
-				goto done;
-			/*
-			 * choose the one that's been least recently used
-			 * or has had the least uses in the last 1.5 
-			 * intervals.
-			 */
-			if (victim == NULL)
-				victim = ipf;
-			else if (ipf->ipf_timer < victim->ipf_timer
-			    || (ipf->ipf_timer == victim->ipf_timer
-				&& ipf->ipf_last_uses + ipf->ipf_uses <
-				    victim->ipf_last_uses + victim->ipf_uses)) {
-				if (victim->ipf_hash != ipf->ipf_hash)
-					IPFLOW_UNLOCK(victim);
-				victim = ipf;
-			}
-		}
-		if (victim && victim->ipf_hash != idx)
-			IPFLOW_HEAD_UNLOCK(head);
-	}
-	ipf = victim;
-    done:
-	/*
-	 * Remove the entry from the flow table.
-	 */
-	LIST_REMOVE(ipf, ipf_next);
-	IPFLOW_UNLOCK(ipf);
-
-	ipflow_addstats(ipf);
-	RTFREE(ipf->ipf_ro.ro_rt);
-	return ipf;
-}
-
-static void
-ipflow_free(struct ipflow *ipf)
-{
-	/*
-	 * Remove the flow from the hash table.
-	 */
-	LIST_REMOVE(ipf, ipf_next);
-
-	ipflow_addstats(ipf);
-	RTFREE(ipf->ipf_ro.ro_rt);
-	ipflow_inuse--;
-	free(ipf, M_IPFLOW);
-}
-
-void
-ipflow_slowtimo(void)
-{
-	struct ipflow *ipf;
-	int idx;
-
-	for (idx = 0; idx < IPFLOW_HASHSIZE; idx++) {
-		struct ipflow_head *head = &ipflows[idx];
-
-		IPFLOW_HEAD_LOCK(head);
-		ipf = LIST_FIRST(&head->ipfh_head);
-		while (ipf != NULL) {
-			struct ipflow *next_ipf = LIST_NEXT(ipf, ipf_next);
-			if (--ipf->ipf_timer == 0) {
-				ipflow_free(ipf);
-			} else {
-				ipf->ipf_last_uses = ipf->ipf_uses;
-				ipf->ipf_ro.ro_rt->rt_use += ipf->ipf_uses;
-				ipstat.ips_forward += ipf->ipf_uses;
-				ipstat.ips_fastforward += ipf->ipf_uses;
-				ipf->ipf_uses = 0;
-			}
-			ipf = next_ipf;
-		}
-		IPFLOW_HEAD_UNLOCK(head);
-	}
-}
-
-void
-ipflow_create(const struct route *ro, struct mbuf *m)
-{
-	const struct ip *const ip = mtod(m, struct ip *);
-	struct ipflow *ipf;
-
-	/*
-	 * Don't create cache entries for ICMP messages.
-	 */
-	if (!ipflow_active || ip->ip_p == IPPROTO_ICMP)
-		return;
-	/*
-	 * See if an existing flow struct exists.  If so remove it from it's
-	 * list and free the old route.  If not, try to malloc a new one
-	 * (if we aren't at our limit).
-	 */
-	ipf = ipflow_lookup(ip);
-	if (ipf == NULL) {
-		if (ipflow_inuse == IPFLOW_MAX) {
-			ipf = ipflow_reap();
-		} else {
-			ipf = (struct ipflow *) malloc(sizeof(*ipf), M_IPFLOW,
-						       M_NOWAIT);
-			if (ipf == NULL)
-				return;
-			ipflow_inuse++;
-		}
-		bzero((caddr_t) ipf, sizeof(*ipf));
-
-		ipf->ipf_hash = ipflow_hash(ip->ip_dst, ip->ip_src, ip->ip_tos);
-		ipf->ipf_dst = ip->ip_dst;
-		ipf->ipf_src = ip->ip_src;
-		ipf->ipf_tos = ip->ip_tos;
-
-		IPFLOW_LOCK(ipf);
-	} else {
-		LIST_REMOVE(ipf, ipf_next);
-
-		ipflow_addstats(ipf);		/* add stats to old route */
-		RTFREE(ipf->ipf_ro.ro_rt);	/* clear reference */
-		ipf->ipf_uses = ipf->ipf_last_uses = 0;
-		ipf->ipf_errors = ipf->ipf_dropped = 0;
-	}
-
-	/*
-	 * Fill in the updated information.
-	 */
-	ipf->ipf_ro = *ro;
-	RT_LOCK(ro->ro_rt);
-	RT_ADDREF(ro->ro_rt);
-	RT_UNLOCK(ro->ro_rt);
-	ipf->ipf_timer = IPFLOW_TIMER;
-	/*
-	 * Insert into the approriate bucket of the flow table.
-	 */
-	LIST_INSERT_HEAD(&ipflows[ipf->ipf_hash].ipfh_head, ipf, ipf_next);
-	IPFLOW_UNLOCK(ipf);
-}
-
-static void
-ipflow_init(void)
-{
-	int idx;
-
-	for (idx = 0; idx < IPFLOW_HASHSIZE; idx++) {
-		struct ipflow_head *head = &ipflows[idx];
-		LIST_INIT(&head->ipfh_head);
-		mtx_init(&head->ipfh_mtx, "ipflow list head", NULL, MTX_DEF);
-	}
-}
-SYSINIT(ipflow, SI_SUB_PROTO_DOMAIN, SI_ORDER_ANY, ipflow_init, 0);
Index: netinet/ip_flow.h
===================================================================
RCS file: /home/ncvs/src/sys/netinet/ip_flow.h,v
retrieving revision 1.5
diff -u -p -r1.5 ip_flow.h
--- netinet/ip_flow.h	1 Sep 2003 05:12:36 -0000	1.5
+++ netinet/ip_flow.h	11 Nov 2003 18:18:18 -0000
@@ -1,64 +1,4 @@
-/*-
- * Copyright (c) 1998 The NetBSD Foundation, Inc.
- * All rights reserved.
- *
- * This code is derived from software contributed to The NetBSD Foundation
- * by the 3am Software Foundry ("3am").  It was developed by Matt Thomas.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. All advertising materials mentioning features or use of this software
- *    must display the following acknowledgement:
- *	This product includes software developed by the NetBSD
- *	Foundation, Inc. and its contributors.
- * 4. Neither the name of The NetBSD Foundation nor the names of its
- *    contributors may be used to endorse or promote products derived
- *    from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
- * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
- * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
- * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
- * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- *
- * $FreeBSD: src/sys/netinet/ip_flow.h,v 1.5 2003/09/01 05:12:36 sam Exp $
+/*
+ * Gone...
  */
 
-#ifndef _NETINET_IP_FLOW_H
-#define _NETINET_IP_FLOW_H
-
-struct ipflow {
-	LIST_ENTRY(ipflow) ipf_next;	/* next ipflow in bucket */
-	struct in_addr ipf_dst;		/* destination address */
-	struct in_addr ipf_src;		/* source address */
-
-	/* NB: this assumes the size of the list head hash table is <=256 */
-	u_int8_t ipf_hash;		/* index in list head table */
-	u_int8_t ipf_tos;		/* type-of-service */
-	struct route ipf_ro;		/* associated route entry */
-	u_long ipf_uses;		/* number of uses in this period */
-
-	int ipf_timer;			/* remaining lifetime of this entry */
-	u_long ipf_dropped;		/* ENOBUFS returned by if_output */
-	u_long ipf_errors;		/* other errors returned by if_output */
-	u_long ipf_last_uses;		/* number of uses in last period */
-};
-
-struct ipflow_head {
-	LIST_HEAD(ipflowhead, ipflow) ipfh_head;
-	struct mtx ipfh_mtx;
-};
-
-#endif
Index: netinet/ip_fw2.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet/ip_fw2.c,v
retrieving revision 1.43
diff -u -p -r1.43 ip_fw2.c
--- netinet/ip_fw2.c	7 Nov 2003 23:26:57 -0000	1.43
+++ netinet/ip_fw2.c	11 Nov 2003 18:18:18 -0000
@@ -463,13 +463,16 @@ verify_rev_path(struct in_addr src, stru
 		dst->sin_len = sizeof(*dst);
 		dst->sin_addr = src;
 
-		rtalloc_ign(&ro, RTF_CLONING|RTF_PRCLONING);
+		rtalloc_ign(&ro, RTF_CLONING);
 	}
 
-	if ((ro.ro_rt == NULL) || (ifp == NULL) ||
-	    (ro.ro_rt->rt_ifp->if_index != ifp->if_index))
+	if (ro.ro_rt == NULL)
 		return 0;
-
+	if ((ifp == NULL) || (ro.ro_rt->rt_ifp->if_index != ifp->if_index)) {
+		RTFREE(ro.ro_rt);
+		return 0;
+	}
+	RTFREE(ro.ro_rt);
 	return 1;
 }
 
@@ -1160,7 +1163,6 @@ send_pkt(struct ipfw_flow_id *id, u_int3
 	struct mbuf *m;
 	struct ip *ip;
 	struct tcphdr *tcp;
-	struct route sro;	/* fake route */
 
 	MGETHDR(m, M_DONTWAIT, MT_HEADER);
 	if (m == 0)
@@ -1226,12 +1228,8 @@ send_pkt(struct ipfw_flow_id *id, u_int3
 	 */
 	ip->ip_ttl = ip_defttl;
 	ip->ip_len = m->m_pkthdr.len;
-	bzero (&sro, sizeof (sro));
-	ip_rtaddr(ip->ip_dst, &sro);
 	m->m_flags |= M_SKIP_FIREWALL;
-	ip_output(m, NULL, &sro, 0, NULL, NULL);
-	if (sro.ro_rt)
-		RTFREE(sro.ro_rt);
+	ip_output(m, NULL, NULL, 0, NULL, NULL);
 }
 
 /*
Index: netinet/ip_icmp.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet/ip_icmp.c,v
retrieving revision 1.81
diff -u -p -r1.81 ip_icmp.c
--- netinet/ip_icmp.c	29 Oct 2003 05:40:07 -0000	1.81
+++ netinet/ip_icmp.c	11 Nov 2003 18:18:19 -0000
@@ -52,11 +52,15 @@
 #include <net/route.h>
 
 #include <netinet/in.h>
+#include <netinet/in_pcb.h>
 #include <netinet/in_systm.h>
 #include <netinet/in_var.h>
 #include <netinet/ip.h>
 #include <netinet/ip_icmp.h>
 #include <netinet/ip_var.h>
+#include <netinet/tcp.h>
+#include <netinet/tcp_var.h>
+#include <netinet/tcpip.h>
 #include <netinet/icmp_var.h>
 
 #ifdef IPSEC
@@ -120,7 +124,7 @@ int	icmpprintfs = 0;
 #endif
 
 static void	icmp_reflect(struct mbuf *);
-static void	icmp_send(struct mbuf *, struct mbuf *, struct route *);
+static void	icmp_send(struct mbuf *, struct mbuf *);
 static int	ip_next_mtu(int, int);
 
 extern	struct protosw inetsw[];
@@ -165,6 +169,18 @@ icmp_error(n, type, code, dest, destifp)
 	if (n->m_flags & (M_BCAST|M_MCAST))
 		goto freeit;
 	/*
+	 * Limit sending of ICMP host unreachable messages.
+	 * If we are acting as a router and someone is doing a sweep
+	 * scan (eg. nmap and/or numerous windows worms) for destinations
+	 * we are the gateway for but are not reachable (ie. a /24 on a
+	 * interface and only a couple of hosts on the ethernet) we would
+	 * generate a storm of ICMP host unreachable messages.
+	 */
+	if (type == ICMP_UNREACH && code == ICMP_UNREACH_HOST) {
+		if (badport_bandlim(BANDLIM_ICMP_UNREACH_HOST) < 0)
+			goto freeit;
+	}
+	/*
 	 * First, formulate icmp message
 	 */
 	m = m_gethdr(M_DONTWAIT, MT_HEADER);
@@ -233,27 +249,34 @@ freeit:
 	m_freem(n);
 }
 
-static struct sockaddr_in icmpsrc = { sizeof (struct sockaddr_in), AF_INET };
-static struct sockaddr_in icmpdst = { sizeof (struct sockaddr_in), AF_INET };
-static struct sockaddr_in icmpgw = { sizeof (struct sockaddr_in), AF_INET };
-
 /*
  * Process a received ICMP message.
  */
 void
 icmp_input(m, off)
-	register struct mbuf *m;
+	struct mbuf *m;
 	int off;
 {
 	int hlen = off;
-	register struct icmp *icp;
-	register struct ip *ip = mtod(m, struct ip *);
-	int icmplen = ip->ip_len;
-	register int i;
+	struct icmp *icp;
 	struct in_ifaddr *ia;
+	struct ip *ip = mtod(m, struct ip *);
+	int icmplen = ip->ip_len;
+	int i, code;
 	void (*ctlfunc)(int, struct sockaddr *, void *);
-	int code;
+	struct sockaddr_in icmpsrc, icmpdst, icmpgw;
 
+	/* Initialize */
+	bzero(&icmpsrc, sizeof(icmpsrc));
+	icmpsrc.sin_len = sizeof(struct sockaddr_in);
+	icmpsrc.sin_family = AF_INET;
+	bzero(&icmpdst, sizeof(icmpdst));
+	icmpdst.sin_len = sizeof(struct sockaddr_in);
+	icmpdst.sin_family = AF_INET;
+	bzero(&icmpgw, sizeof(icmpgw));
+	icmpgw.sin_len = sizeof(struct sockaddr_in);
+	icmpgw.sin_family = AF_INET;
+	
 	/*
 	 * Locate icmp structure in mbuf, and check
 	 * that not corrupted and of at least minimum length.
@@ -387,7 +410,7 @@ icmp_input(m, off)
 			printf("deliver to protocol %d\n", icp->icmp_ip.ip_p);
 #endif
 		icmpsrc.sin_addr = icp->icmp_ip.ip_dst;
-#if 1
+
 		/*
 		 * MTU discovery:
 		 * If we got a needfrag and there is a host route to the
@@ -397,40 +420,38 @@ icmp_input(m, off)
 		 * notice that the MTU has changed and adapt accordingly.
 		 * If no new MTU was suggested, then we guess a new one
 		 * less than the current value.  If the new MTU is 
-		 * unreasonably small (arbitrarily set at 296), then
-		 * we reset the MTU to the interface value and enable the
-		 * lock bit, indicating that we are no longer doing MTU
-		 * discovery.
+		 * unreasonably small (defined by sysctl tcp_minmss), then
+		 * we don't update the MTU value.
+		 *
+		 * XXX: All this should be done in tcp_mtudisc() because
+		 * the way we do it now, everyone can send us bogus ICMP
+		 * MSGSIZE packets for any destination. By doing this far
+		 * higher in the chain we have a matching tcp connection.
+		 * Thus spoofing is much harder. However there is no easy
+		 * non-hackish way to pass the new MTU up to tcp_mtudisc().
+		 * Also see next XXX regarding IPv4 AH TCP.
 		 */
 		if (code == PRC_MSGSIZE) {
-			struct rtentry *rt;
 			int mtu;
+			struct in_conninfo inc;
+
+			bzero(&inc, sizeof(inc));
+			inc.inc_flags = 0; /* IPv4 */
+			inc.inc_faddr = icmpsrc.sin_addr;
+
+			mtu = ntohs(icp->icmp_nextmtu);
+			if (!mtu)
+				mtu = ip_next_mtu(mtu, 1);
+
+			if (mtu >= max(296, (tcp_minmss + sizeof(struct tcpiphdr))))
+				tcp_hc_updatemtu(&inc, mtu);
 
-			rt = rtalloc1((struct sockaddr *)&icmpsrc, 0,
-				      RTF_CLONING | RTF_PRCLONING);
-			if (rt && (rt->rt_flags & RTF_HOST)
-			    && !(rt->rt_rmx.rmx_locks & RTV_MTU)) {
-				mtu = ntohs(icp->icmp_nextmtu);
-				if (!mtu)
-					mtu = ip_next_mtu(rt->rt_rmx.rmx_mtu,
-							  1);
 #ifdef DEBUG_MTUDISC
-				printf("MTU for %s reduced to %d\n",
-					inet_ntoa(icmpsrc.sin_addr), mtu);
+			printf("MTU for %s reduced to %d\n",
+				inet_ntoa(icmpsrc.sin_addr), mtu);
 #endif
-				if (mtu < 296) {
-					/* rt->rt_rmx.rmx_mtu =
-						rt->rt_ifp->if_mtu; */
-					rt->rt_rmx.rmx_locks |= RTV_MTU;
-				} else if (rt->rt_rmx.rmx_mtu > mtu) {
-					rt->rt_rmx.rmx_mtu = mtu;
-				}
-			}
-			if (rt)
-				rtfree(rt);
 		}
 
-#endif
 		/*
 		 * XXX if the packet contains [IPv4 AH TCP], we can't make a
 		 * notification to TCP layer.
@@ -607,7 +628,6 @@ icmp_reflect(m)
 	struct in_addr t;
 	struct mbuf *opts = 0;
 	int optlen = (ip->ip_hl << 2) - sizeof(struct ip);
-	struct route *ro = NULL, rt;
 
 	if (!in_canforward(ip->ip_src) &&
 	    ((ntohl(ip->ip_src.s_addr) & IN_CLASSA_NET) !=
@@ -618,8 +638,6 @@ icmp_reflect(m)
 	}
 	t = ip->ip_dst;
 	ip->ip_dst = ip->ip_src;
-	ro = &rt;
-	bzero(ro, sizeof(*ro));
 	/*
 	 * If the incoming packet was addressed directly to us,
 	 * use dst as the src for the reply.  Otherwise (broadcast
@@ -640,7 +658,7 @@ icmp_reflect(m)
 				goto match;
 		}
 	}
-	ia = ip_rtaddr(ip->ip_dst, ro);
+	ia = ip_rtaddr(ip->ip_dst);
 	/* We need a route to do anything useful. */
 	if (ia == NULL) {
 		m_freem(m);
@@ -730,12 +748,10 @@ match:
 	}
 	m_tag_delete_nonpersistent(m);
 	m->m_flags &= ~(M_BCAST|M_MCAST);
-	icmp_send(m, opts, ro);
+	icmp_send(m, opts);
 done:
 	if (opts)
 		(void)m_free(opts);
-	if (ro && ro->ro_rt)
-		RTFREE(ro->ro_rt);
 }
 
 /*
@@ -743,10 +759,9 @@ done:
  * after supplying a checksum.
  */
 static void
-icmp_send(m, opts, rt)
+icmp_send(m, opts)
 	register struct mbuf *m;
 	struct mbuf *opts;
-	struct route *rt;
 {
 	register struct ip *ip = mtod(m, struct ip *);
 	register int hlen;
@@ -769,7 +784,7 @@ icmp_send(m, opts, rt)
 		       buf, inet_ntoa(ip->ip_src));
 	}
 #endif
-	(void) ip_output(m, opts, rt, 0, NULL, NULL);
+	(void) ip_output(m, opts, NULL, 0, NULL, NULL);
 }
 
 n_time
@@ -783,7 +798,6 @@ iptime()
 	return (htonl(t));
 }
 
-#if 1
 /*
  * Return the next larger or smaller MTU plateau (table from RFC 1191)
  * given current value MTU.  If DIR is less than zero, a larger plateau
@@ -821,7 +835,6 @@ ip_next_mtu(mtu, dir)
 		}
 	}
 }
-#endif
 
 
 /*
